package cz.drg.clasificator.args.argevaluation;

/**
 * Interface for any factory that is used in the ProgramExecutor for loose binding
 * between the two.
 * 
 * @author Pavel Jirasek
 */
public interface EvaluatorFactory {

    /**
     * Gets evaluator based on the parameter. Usually all arguments supported and specified
     * in the program settings should return evaluator for that argument.
     * 
     * @param name
     * @return 
     */
    public Evaluator getEvaluator(String name);
    
}
